/*******************************************/
/*										   */
/*	File:	ChromaKeyMovie.protos.h		   */
/*										   */
/*	By:		Jason Hodges-Harris			   */
/*										   */
/*******************************************/


#ifndef __CHROMAPROTOSHEADER__
#define __CHROMAPROTOSHEADER__


// Mac Toolbox protos 


#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __MOVIES__
#include <Movies.h>
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif


// Program headers

#ifndef __CHROMAPPHEADER__
#include "ChromaKeyMovie.app.h"
#endif


// doevent.c prototypes

void 			DoEvent (EventRecord *EventPtr);		// process event
void 			HandleMouseDown(EventRecord *eventPtr);// handle mouse down events
void 			DoDiskEvt(EventRecord *eventPtr);		// handle disk inserted events

// eventloop.c prototypes

void 			EventLoop (void);						// main program event loop


// menu.c prototypes

void 			MenuBarInit (void);									// init menubar
void			DoAdjustMenus(void);								// adjust valid menus
void			DoMenuCommand(long menuResult);						// perform menu selection
void			DoAdjustFileMenu(void);			// Adjust file menu
void			DoAdjustEditMenu(void);			// Adjust Edit menu
void			DoAdjustKeyMode(void);			// Adjust Chroma key menu
void 			DoAdjustOptions(Boolean playAllFrames, Boolean loopMovie);	// Adjust Options menu


// start.c prototypes

void			InitGlobals(void);							// initialise global variables
void			TestforQuickTimeVersion(void);				// test for QuickTime & version


// moviecontrol.c prototypes

Boolean			PlayMovieChroma(void);
OSErr			LoadOneMovie(MovieDocHndl theDocH);
void			TransparentColor(void);
Boolean			SetPlayAllFrames(Boolean playAllFrames);
Boolean			SetLoopMovie(Boolean loopMovie);
void 			TransparentKeyMode(WindowPtr theWindow);
void 			ModifierTrackMode(WindowPtr theWindow);
void 			VideoGraphicsMode(WindowPtr theWindow, Boolean SetVGM);
OSErr			DestroyModifierTrack(MovieDocHndl theDocH);


// windows.c prototypes

long 			DisplayAlert (short dialogID,short errStrID,short StrIDindex);
void			DragSelWind(WindowPtr window,Point mouseloc);	// drag window
void			DoGoAwayWind(WindowPtr window,Point mouseLoc);	// window close button selected
void			DisposeWindowDocs (WindowPtr window);			// dispose window documents
void			DoWindUpdate(WindowPtr window);		// update dirty open window
CWindowPtr		OpenCWindow(void);


#endif  // __CHROMAPROTOSHEADER__