/*
	File:		QTInternals.h

	Contains:	Functions dealing with dumping internal movie information.

	Written by:	DTS

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

	   <1>	 	1/4/95	khs		first file
	   
*/

#pragma once


// INCLUDES
#include <Movies.h>
#include <stdio.h>

#ifdef __MWERKS__
#include <sioux.h>
#endif

// TYPEDEFS & DATA STRUCTURES

// FUNCTION PROTOTYPES
void ShowMovieTrackInfo(Movie theMovie);														// display track information about movies
void ShowMovieVideoInfo(Movie theMovie);     													// display video related information
void ShowMovieSoundInfo(Movie theMovie);														// display sound related information
void ShowGlobalMovieInfo(Movie theMovie);														// display global information related to the movie and system
void ShowTextTrackInformation(Movie theMovie);											// dump text track information
pascal long QTUCountKeySamples(Movie theMovie, OSType theMediaType);		// get key samples