/*
	File:		BigEasyStandardControls.h

	Contains:	xxx put contents here xxx

	Written by:	xxx put writers here xxx

	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.

    This file is used in these builds: Warhol

	Change History (most recent first):

		 <3>	12/19/91	JB		removing think 4.0 code
		 <2>	 5/28/91	JB		Added prototypes so we can require them

	To Do:
*/

/*
  * file: BigEasyStandardControls.h
  *
  * started 25 May 1990 12:07:24 Friday at 310 Nobel
  * 
  * david van brink
  *
  */


enum
/*
  * different number types that the slider can operate in.
  */
	{
	longNum,
	fixedNum,
	fracNum,
	floatNum
	};

typedef void (*becsDrawValueProcPtr)(easyControl);		

typedef struct
/*
  * specifies a style of slider
  */
	{
	char numberType;
	short sWidth,sHeight;				/* size of slider, figured from rect	*/
	short tWidth,tHeight;				/* size of text rect, and point size	*/
	becsDrawValueProcPtr drawValue;						/* to convert value to string		*/
	} tSliderStyle;

typedef struct
/*
  * specifies a style of toggle
  */
	{
	short p;							/* ID of PICT resource to draw (or zero to not)		*/
	char c[40];						/* text string to insert (or zero for none)			*/
	} tToggleStyle;

enum
/*
  * variation flags for slider control
  */
	{
	drawRightSlider = 1					/* draw the right-hand part of the slide range */
	};

enum
/*
  * Different variation flags for the toggle control
  */
	{
	noOptionsToggle = 0,
	toggleToggle = 1,					/* the button has two states		*/
	roundToggle = 2,
	dontTrackToggle = 4,				/* just take the 1st click			*/
	checkboxToggle = 8					/* mark "X" in toggle			*/
	
	};

extern easyControlType sliderType;
extern easyControlType toggleType;

