/*
  File:			BigEasyVideoGrabber.h
  Contains:		Header Files for the Application.
  Written by:	David Van Brink / QT Engineering
  Copyright:	 1991-1994 by Apple Computer, Inc., all rights reserved.
  Change History (most recent first):
  <2>	 	12/4/94		khs		changed the format of the file to the new look and feel
  <1>	 	12/12/91	dvb		Started with 1.0
  To Do:
*/


// INCLUDES
#include <QuickTimeComponents.h>


// TYPES
typedef struct
{
	ComponentInstance sg;						/* Sequence Grabber */
	ComponentInstance vc;						/* Video Channel */
	Rect preferredRect;							/* Size of digitizing area */
} EasyVideoGrabberRecord, * EasyVideoGrabber;


// FUNCTION PROTOTYPES
EasyVideoGrabber NewEasyVideoGrabber(Rect* outputSize);	/* returns the biggest it'll draw */
Boolean GrabEasyVideoGrabber(EasyVideoGrabber evg,
							 Rect* r);					/* draws into current port */
void DisposeEasyVideoGrabber(EasyVideoGrabber evg);		/* close everything down */


