/*
	A key filter for edit fields that contain numbers that allow decimals and 
	the minus sign.

	Created 29 Jan 1996 by EGH
	
	Copyright  1996, Apple Computer, Inc. All rights reserved.
*/

#include "CKeyFilters.h"

EKeyStatus CKeyFilters::RealNumberFieldPositive(
	const EventRecord &inKeyEvent)
{
	EKeyStatus theKeyStatus = keyStatus_PassUp;
	Char16 theKey = inKeyEvent.message;
	Char16 theChar = theKey & charCodeMask;
	
	if (theChar == '.')
		theKeyStatus = keyStatus_Input;
	else
		theKeyStatus = IntegerField(inKeyEvent);
	
	return theKeyStatus;
}

EKeyStatus CKeyFilters::RealNumberField(
	const EventRecord &inKeyEvent)
{
	EKeyStatus theKeyStatus = keyStatus_PassUp;
	Char16 theKey = inKeyEvent.message;
	Char16 theChar = theKey & charCodeMask;
	
	if (theChar == '.')
		theKeyStatus = keyStatus_Input;
	else if (theChar == '-')
		theKeyStatus = keyStatus_Input;
	else
		theKeyStatus = IntegerField(inKeyEvent);
	
	return theKeyStatus;
}