/*
	A set of static functions that know how to create QTVR movies from a source PICT file.
	
	Created 29 January 1996 by Edward Harp. Based on code by Pete Falco and msnm.
	
	Copyright  1996, Apple Computer, Inc.
*/

#ifndef _CMovieMaker_
#define _CMovieMaker_

#ifndef __MOVIES__
#include <Movies.h>
#endif

#include "CApp.h"

class CMovieMaker
{
public:
	
	static Boolean MakeAMovie(
		Boolean inReplaceFiles,
		const FSSpec &inSrcSpec,
		const FSSpec &inTileSpec,
		const FSSpec &inDestSpec,
		Int16 inWidth,
		Int16 inHeight,
		Fixed inPan,
		Fixed inTilt,
		Fixed inZoom,
		CodecType inCodec,
		CodecQ inSpatialQuality,
		Int16 inDepth,
		ProgressProc inProgressProc);

	static void CreateTileMovie(
		PicHandle inPicH,
		const FSSpec &inTileSpec,
		CodecType inCodec,
		CodecQ inSpatialQuality,
		Int16 inDepth,
		ProgressProc inProgressProc);
	
	static void CreateSingleNodeMovie(
		const FSSpec &inTileSpec,
		const FSSpec &inMovieSpec,
		Int16 inWidth,
		Int16 inHeight,
		Fixed inPan,
		Fixed inTilt,
		Fixed inZoom);
	
	static pascal OSErr QTProgress(
		short inMessage,
		Fixed inCompleteness,
		long inRefcon);
};

#endif










