/*
	A window that provides the a interface for creating QTVR movies.
	
	Created 29 Jan 1996 by EGH
	
	Copyright  1996, Apple Computer, Inc. All rights reserved.
*/

#pragma once

#ifndef __MOVIES__
#include <Movies.h>
#endif

#include <LDialogBox.h>

class CPict2VRWindow :
	public LDialogBox,
	public LBroadcaster
{
public:

	enum { class_ID = 'p2vr' };
	
	static CPict2VRWindow *CreatePict2VRWindowWindowStream(
		LStream	*inStream);
	
	CPict2VRWindow(
		LStream	*inStream);
	
	virtual ~CPict2VRWindow();
	
	virtual void FinishCreateSelf();
	
	virtual void ListenToMessage(
		MessageT inMessage,
		void *ioParam);
	
	void SetPictFile(
		FSSpec *inMacFSSpec);
	
	void SetCompText();

private:

	FSSpec mSrcSpec;
	FSSpec mTileSpec;
	FSSpec mDestSpec;
	PaneIDT mCreate;
	Int16 mWidth;
	Int16 mHeight;
	CodecType mCodec;
	CodecQ mSpatialQuality;
	Int16 mDepth;
	Rect mPictFrame;
};
