/*
	A window that provides the user interface for editing preferences.
	
	Created 29 Jan 1996 by EGH
	
	Copyright  1996, Apple Computer, Inc. All rights reserved.
*/

#pragma once

#include <Movies.h>

#include <LDialogBox.h>

#include "CApp.h"

class CPrefsWindow :
	public LDialogBox,
	public LBroadcaster
{
public:

	enum { class_ID = 'pref' };
	
	static CPrefsWindow *CreatePrefsWindowWindowStream(
		LStream	*inStream);
	
	CPrefsWindow(
		LStream	*inStream);
	
	virtual ~CPrefsWindow();
	
	virtual void FinishCreateSelf();
	
	virtual void ListenToMessage(
		MessageT inMessage,
		void *ioParam);
	
	void SetCompText();

protected:

	virtual void FindCommandStatus(
		CommandT inCommand,
		Boolean &outEnabled,
		Boolean &outUsesMark,
		Char16 &outMark,
		Str255 outName);

private:

	CodecType mCodec;
	CodecQ mSpatialQuality;
	Int16 mDepth;
	
	P2VRPrefsHdl mPrefsHdl;
};
