/*
  File:			MoviePrefs.h
  Contains:		Movie prefereneces routine's headers and data structures
  Written by:	Jason Hodges-Harris & Don Swatman
  Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
*/

#ifndef __MOVIEPREFS__
#define __MOVIEPREFS__

#include <Types.h>

//==============================================
// MovieOptionsType
//
// Deals with various options used to set up the
// movies.
//==============================================

#define	kAutoCloseWind true
#define	kUserCloseWind false

#define	kHasMovieController true
#define	kNoMovieController  false

struct MovieOptionsType
{
	Boolean closeAtEnd;      // Automatically close window when movie finishes playing	
	Boolean hasController;   // Movie has a controller
	Boolean do20to10Loop;    // Do a loop
	short   loopFrom;        //   Where to start loop in seconds
	short   loopTo;          //   Where loop should go to in seconds
	short   rateChangeDelay; // When the movie rate should change (0 = no changes ) in seconds
	short   slaveAheadBy;    // Time slave is ahead of master in seconds
	short   slaveStartDelay; // Time master must run before slave starts in seconds
};
typedef struct MovieOptionsType MovieOptionsType,
	*MovieOptionsPtr, **MovieOptionsHdl;

//----------------------------------------------
// Globals
//----------------------------------------------
extern MovieOptionsType gDefaultMoviePrefs;  // Global for the default prefences

//----------------------------------------------
// Prototypes
//----------------------------------------------
void SetUpDefaultMoviePref ( MovieOptionsType *theOptions );

OSErr OneMoviePref( MovieOptionsType *theOptions,
										Boolean hasSlaveMovie );

void InitMoviePrefs(void);
void KillMoviePrefs(void);

#endif