/*
  File:			MovieStuff.h
  Contains:		Movie handling routine's headers.
  Written by:	Jason Hodges-Harris & Don Swatman
  Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
*/


#ifndef __MOVIESTUFF__
#define __MOVIESTUFF__

#include <Windows.h>
#include <Types.h>

//----------------------------------------------
// Prototypes
//----------------------------------------------

OSErr OpenMovieWindow ( WindowPtr pWindow,
												Boolean   doesAutoClose,
												Boolean   hasControler  );

OSErr CloseMovieWindow( WindowPtr pWindow,
												WindowPtr *pSlaveWindow  );

#define	kStartFromBegining true
#define	kStartAtCurrentPos false

OSErr StartMovieWindow( WindowPtr pWindow,
												Boolean   fromBegining  );
												
void UpdateMovieWindow (  WindowPtr pWindow   );

Boolean ServiceMovieTasks ( WindowPtr pWindow,
														const EventRecord *theEvent );

#define	kInSync 0
#define	kOneThird -1

OSErr SetupSlaveMovie ( WindowPtr pMasterWindow,
												WindowPtr pSlaveWindow,
												short     slaveAheadBy,
												short     slaveDelayStart );

OSErr SetupMovieRate( WindowPtr pWindow,
											short delayBeforeChange  );

OSErr SetupLoop ( WindowPtr pWindow,
									short loopWhen,
									short loopTo  );

Boolean IsMoviePlaying (void);

void InitMovieGlobals(void);
void KillMovieGlobals(void);


#endif