/*
  File:			WindStuff.h
  Contains:		Window handling routine headers.
  Written by:	Jason Hodges-Harris & Don Swatman
  Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
*/



#ifndef __WINDSTUFF__
#define __WINDSTUFF__

#include <Types.h>
#include <Windows.h>


//----------------------------------------------
// Globals
//----------------------------------------------

#define kMaxWindows 5  // Maxinum windows we can display

extern WindowPtr gTheWinds[kMaxWindows];  // List of all the windows
extern Boolean	 gDone;                   // Set to true to quit program
	
//----------------------------------------------
// Prototypes
//----------------------------------------------

Boolean IsOurWindow( WindowPtr pWindow);
short GetWindowNum ( WindowPtr pWindow );
Boolean IsFreeWind( short *newWindNum, short howManyNeeded);


void CloseOurWindow ( short windNum );
void CloseAllWindows(void);

#define kWindAtFront (WindowPtr)-1L  // Create a window at the front
void CreateWindow ( short windNum, Str255 theTitle, WindowPtr pWindowBehind );

void DragSelWind( WindowPtr window,
									Point     mouseLoc);

void DoGoAwayWind ( WindowPtr pWindow,
										Point     mouseLoc);
void	DoWindUpdate ( WindowPtr pWindow );

void AboutBox(void);

#endif